module Parser
  # Html Base
  class Base

    def initialize(url, options)
      @source = Parser.connect(url)
      @copyright = copyright(options)
      @limit_pages ||= 5
      @delay ||= 10
    end

    def next_page(css_selector)
      @next_page = @source.links_with(css_selector)[0]
    end

    def parse_all
      result = parse_page
      next_page()
      #concat all pages into one array
      i = 1
      ap "Parsing #{i} page"
      until @next_page.nil? || i == @limit_pages
        sleep @delay
        i += 1
        ap "Parsing #{i} page"
        @source = @next_page.click
        next_page()
        result.concat(parse_page)
      end
      result
    end
    def parse_page
    end
    def collect_between(first, last)
      return nil if first.nil?
      first == last ? [first] : [first, *collect_between(first.next, last)]
    end
    def copyright(options)
      source = options[:source]
      {
        url: source['copyright'],
        title: source['copyright_title']
      }
    end

    def click(link)
      agent = Mechanize.new
      agent.ignore_bad_chunking = true
      agent.pluggable_parser.default = Mechanize::Page
      agent.click(link)
    end

  end
end
