# add new parser source here
module Enable
  def fitness(source)
    lambda do |item|
      item["parser"] = Parser::Exercise.new(item["url"], source: source) and next if item["type"] == "exercises"
      item["parser"] = Parser::Fitness.new(item["url"], source: source)
    end
  end

  def news(source)
    lambda { |item| item["parser"] = Parser::News.new(item["url"], source: source) }
  end

  def local(source)
    lambda { |item| item["parser"] = Parser::News.new(item["file"], {type: :file, source: source}) }
  end

  def news_nl(source)
    lambda { |item| item["parser"] = Parser::NewsNl.new(item["url"], source: source) }
  end

  def news_fr(source)
    lambda {|item| item["parser"] = Parser::NewsFr.new(item["url"], source: source)}
  end

  def news_az(source)
    lambda {|item| item["parser"] = Parser::NewsAZ.new(item["url"], source: source)}
  end

  def news_kz(source)
    lambda {|item| item["parser"] = Parser::NewsKZ.new(item["url"], source: source)}
  end

  def method_missing(meth, *args)
    prefix = "enable_"
    meth = meth.to_s
    if meth.start_with?(prefix)
      meth_name = meth.split(prefix).last
      proc = send(meth_name, *args)
      iterate_sources(*args, proc)
    else
      raise "Unknown method #{meth} in Enable class, ssory !"
    end
  end

  def iterate_sources(source, block)
    source["items"].each(&block)
  end
end
