# todo parse all pages first, and download only newest later
module Parser
  class Fitness < Base

    def next_page
      super(:id => 'next_page')
    end

    def parse_page
      # until next page exists
      links = @source.links_with(:class => 'article-headine__link')
      links.map do |link|
        href = link.href
        page = link.click
        article = page.search('div[itemscope]')
        title = article.search('.article-name').text()
        # images stuff
        wrapper = article.search('.article-text__wrapper')
        # if poster_image doesn't exists, it looks like strange promo ads, so skip it
        next if wrapper.search('.article_image__pic').first.nil?
        poster_image = @copyright[:url] + wrapper.search('.article_image__pic').first.attributes['src'].value
        wrapper.search('.article_image__pic').first.remove()
        wrapper.search('.article_image__pic')
        images = wrapper.search('.article_image__pic')
        # expand path for images
        images.map {|image| image.attributes['src'].value = image.attributes['src'].value.prepend(@copyright[:url]); image }
        # remove ad
        wrapper.search('.po_theme').remove()
        wrapper.search('a').remove_attr('href')

        {title: title, content: wrapper.inner_html, poster_image: poster_image}
      end.compact
    end

  end
end
