module Parser
  class Sport
    
    def initialize(source)
      @source = Parser.connect(source)
      @categories = %w(Футбол Хоккей Баскетбол Авто/мото Теннис)
    end

    def parse_in(category)
      @category = category
      @current_page = current_page
      @current_page.search('.anons').map do |news_item|
        href = news_item.css('a').first.attributes['href'].value
        item_page = @current_page.link_with(:href => href).click
        { title: item_page.search('.titleH1').text(), content: item_page.search('.article-textBlock').text() }
      end  
    end

    def current_page
      @source.link_with(:text => @category).click
    end

    def parse_all
      @categories.map { |category| parse_in(category) }
    end   
  end  
end  