module Parser
  class XmlBase
    def initialize(source, options = {})
      if options[:type] == :file
        source = fake_url(source)
      end
      @copyright = copyright(options)
      @source = Parser.connect(source)
      @delay ||= 10
      @enable_tags = tags(options)
    end

    def fake_url(source)
      stream = File.read(source)
      # test_file.com is a random url, just for Mechanize parsing
      url = "http://www.google.com"
      FakeWeb.register_uri(:get, url, :body => stream, :content_type => "application/xml")
      url
    end

    def copyright(options)
      source = options[:source]
      {
        url: source['copyright'],
        title: source['copyright_title']
      }
    end

    def tags(options)
      source = options[:source]
      source['tags']
    end
  end
end